#include <gtk/gtk.h>
#include <glib-object.h>

#include "state.h"
#include "support.h"
#include "own_callbacks.h"

void
read_answer ()
{
	gchar answer[1024] = "\0", wname[32] = "\0";
	gint isown, i;
	GtkWidget *widget;

	impr_sql_answer_zero (global_testplan.tpid, global_testplan.curquestion);

	if (!g_strcmp0 (global_question.type, "single"))
	{
		isown = check_own_form	(1, answer);
		if (isown != 2)
		{
			impr_sql_answer_edit_choosen (answer, global_testplan.tpid, global_question.qnum);
		}
		else
		{
			impr_sql_answer_edit_myself (answer, global_testplan.tpid, global_question.qnum);
		}
	}
	else
	{

		for (i = 0; i < global_question.numanswers; i++)
		{
			g_sprintf (wname, "check%d", i);
			widget = lookup_widget (get_widget ("window1"),wname);
			if (widget != NULL)
			{
				if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
				{
					g_sprintf (answer, "%s", gtk_button_get_label (GTK_BUTTON (lookup_widget (get_widget ("window1"),wname))));
					impr_sql_answer_edit_choosen (answer, global_testplan.tpid, global_testplan.curquestion);
				}
			}
			widget = NULL;
		}

		if (global_question.isown)
		{
			widget = lookup_widget (get_widget ("window1"),"check_own_button");

			if (widget != NULL)
			{
				if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
				{
					impr_sql_answer_edit_myself ((gchar* )gtk_entry_get_text (GTK_ENTRY (lookup_widget (get_widget ("window1"), "check_own_entry"))), global_testplan.tpid, global_testplan.curquestion);
				}
			}
		}
	}
}

gint
request_update_question ()
{
	impr_sql_question_edit (global_question);
	read_answer ();
}
