#include <stdio.h>
#include <stdlib.h>


typedef struct server_struct {
	char servername[128];
	char port[6];
	char protocol_version[128];
	char client_version[128];
} server_st;


int 
init_server_struct 		(char *fileconfig, 
				 char *fileprotocol, 
			         char *fileversion, 
				 server_st *server_info);

int
connect_server 			(server_st server_info);

int
command_close_connection 	(int sockfd);

int
command_end_operation 		(int sockfd);

int
command_find 			(int sockfd, 
				 const char *hw_id,
				 const char *locale, 
				 char *first_name, 
				 char *second_name, 
				 char *email);

int 
command_registr 		(int sockfd, 
				 char* path, 
				 char *first_name, 
				 char *second_name, 
				 char *email, 
				 char *hw_id, 
				 char *locale, 
				 char *comment);

int
command_get_testplan 		(int sockfd, char *path);

int
command_send_attach		(int sockfd, 
				 char *path, 
				 char *filename);

int
command_send_report 		(int sockfd, 
				 char *path, 
				 char *filename);
